using GarmentFactoryContracts.BindingModels;
using GarmentFactoryContracts.BusinessLogicsContracts;
using GarmentFactoryContracts.DI;
using Microsoft.Extensions.Logging;

namespace GarmentFactoryView
{
    public partial class FormImplementers : Form
    {
        private readonly ILogger _logger;

        private readonly IImplementerLogic _logic;

        public FormImplementers(ILogger<FormImplementers> logger, IImplementerLogic logic)
        {
            InitializeComponent();
            _logger = logger;
            _logic = logic;
        }

        private void FormImplementers_Load(object sender, EventArgs e)
        {
            LoadData();
        }

        private void LoadData()
        {
            try
            {
				dataGridView.FillAndConfigGrid(_logic.ReadList(null));
				_logger.LogInformation("Implementers loading");
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, "Implementers loading error");
                MessageBox.Show(ex.Message, "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void ButtonAdd_Click(object sender, EventArgs e)
        {
			var form = DependencyManager.Instance.Resolve<FormImplementer>();
			if (form.ShowDialog() == DialogResult.OK)
			{
                 LoadData();
            }
        }

        private void ButtonEdit_Click(object sender, EventArgs e)
        {
            if (dataGridView.SelectedRows.Count == 1)
            {
				var form = DependencyManager.Instance.Resolve<FormImplementer>();
				form.Id = Convert.ToInt32(dataGridView.SelectedRows[0].Cells["Id"].Value);
				if (form.ShowDialog() == DialogResult.OK)
				{
                     LoadData();
                }
            }
        }

        private void ButtonDel_Click(object sender, EventArgs e)
        {
            if (dataGridView.SelectedRows.Count == 1)
            {
                if (MessageBox.Show("Удалить запись?", "Вопрос", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                {
                    int id = Convert.ToInt32(dataGridView.SelectedRows[0].Cells["Id"].Value);
                    _logger.LogInformation("Deletion of implementer");
                    try
                    {
                        if (!_logic.Delete(new ImplementerBindingModel { Id = id }))
                        {
                            throw new Exception("Ошибка при удалении. Дополнительная информация в логах.");
                        }
                        LoadData();
                    }
                    catch (Exception ex)
                    {
                        _logger.LogError(ex, "Implementer deletion error");
                        MessageBox.Show(ex.Message, "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                }
            }
        }

        private void ButtonUpd_Click(object sender, EventArgs e)
        {
            LoadData();
        }
    }
}